; How to write to DSP registers without any SPC-700 code.
; Makes beep.
;
; ca65 manual_dsp.s
; ld65 -C lorom128.cfg -o manual_dsp.smc manual_dsp.o

.define ROM_NAME "MANUAL DSP"
.include "lorom128.inc"
.include "spc_upload.s"

reset:
	init_cpu
	
	jsr spc_wait_boot
	
	; Upload sample to SPC at $200
	ldy #$0200
	jsr spc_begin_upload
:       lda sample,y
	jsr spc_upload_byte
	cpy #sample_end - sample
	bne :-

	; Do DSP writes to start playing tone
	ldx #$206C
	jsr write_dsp
	ldx #$004C
	jsr write_dsp
	ldx #$FF5C
	jsr write_dsp
	ldx #$025D
	jsr write_dsp
	ldx #$7F00
	jsr write_dsp
	ldx #$7F01
	jsr write_dsp
	ldx #$0002
	jsr write_dsp
	ldx #$0203
	jsr write_dsp
	ldx #$0004
	jsr write_dsp
	ldx #$C305
	jsr write_dsp
	ldx #$2F06
	jsr write_dsp
	ldx #$CF07
	jsr write_dsp
	ldx #$005C
	jsr write_dsp
	ldx #$003D
	jsr write_dsp
	ldx #$004D
	jsr write_dsp
	ldx #$7F0C
	jsr write_dsp
	ldx #$7F1C
	jsr write_dsp
	ldx #$002C
	jsr write_dsp
	ldx #$003C
	jsr write_dsp
	ldx #$014C
	jsr write_dsp
	
@forever:
	jmp @forever


sample:
;.org $200
	;directory:
	.word $204      ; start
	.word $204      ; loop
	
	;sample:
	;sample_loop:
	.byte $B0,$78,$78,$78,$78,$78,$78,$78,$78
	.byte $B3,$78,$78,$78,$78,$78,$78,$78,$78
sample_end:


; Writes high byte of X to SPC-700 DSP register in low byte of X
write_dsp:
	phx
	; Just do a two-byte upload to $00F2-$00F3, so we
	; set the DSP address, then write the byte into that.
	ldy #$00F2
	jsr spc_begin_upload
	pla
	jsr spc_upload_byte     ; low byte of X to $F2
	pla
	jsr spc_upload_byte     ; high byte of X to $F3
	rts
